; txttostr (Text to String)
; by Alban Gervaise
; written on PlusShell v1.0a
; last release 21/04/99


        include "tios.h"

        xdef _ti89
        xdef _nostub

VarNew  = 2616/4
VarOpen = 2608/4

_DEREF macro                ; so must write deref MACRO
 lsl.w #2,\1
 GET_REL_RAM_DWORD $2f,$104+$16,\2
 move.l 0(\2,\1.w),\2
 endm


GET_REL_RAM_DWORD macro
 move.l ($c8),a5
 add.l #\1*4,a5
 move.l (a5),a5
 move.l \2(a5),\3
 endm

_begin              
        movem.l d0-d7/a0-a6,-(a7)

        pea text_value(pc)  ; ask the tios
        ROM_CALL VarOpen    ; to open a string
        lea 4(a7),a7        ;
        tst.w d0            ; if d0=0: error
        beq exit            ; so quit

        move.w 12(a0),d0    ; give the adress of the text file
        _DEREF d0,a0        ;
        move.l a0,text_addr ;
        move.w (a0),taille  ;
        lea 5(a0),a0        ;

        cmp.b #'T',(a0)+    ; good header?
        bne make_error_3    ;
        cmp.b #'8',(a0)+    ;
        bne make_error_3    ;
        cmp.b #'9',(a0)+    ;
        bne make_error_3    ;
        cmp.b #':',(a0)+    ; no... make an error
        bne make_error_3    ;

        pea value(pc)       ; ask a name for the string...and create a string
        ROM_CALL VarNew     ;
        lea 4(a7),a7        ;
        tst.w d0            ; if d0=0=>no string
        beq exit            ;

        move.w #8,d0        ; but now, we have to find it!!!
        _DEREF d0,a0        ; in fact, the handle of the file is 0
        lea 2(a0),a0        ; so check in all folder a variable
        move.w (a0)+,d0     ; with handle=0
        sub.w #1,d0
\loopd0 move.w 12(a0),d1
        _DEREF d1,a1
        lea 2(a1),a1
        move.w (a1)+,d1
        tst.w d1
        beq.s \skip
        sub.w #1,d1
\loopd1 tst.w 12(a1)        ; now we've got it...
        beq.s \ok
\non    lea 14(a1),a1
        dbra.s d1,\loopd1
\skip   lea 14(a0),a0
        dbra.s d0,\loopd0
        bra exit            ; don't have it...so quit (in fact must have it even if it's not the good one! but it's most sure)
\ok     move.l a1,a6
        move.l a1,vat
        clr.l d0
        move.w taille,d0    ; change the size
        addq.w #2,d0         ;
        move.l d0,-(a7)
        move.w 12(a6),-(a7)
        ROM_CALL romfunc::HeapRealloc
        lea 6(a7),a7
        tst.w d0
        beq make_error_4    ; if no more memory...make an error (4th)
        move.w d0,12(a6)
        move.w d0,handle    ; save the handle
        clr.b 9(a6)
        _DEREF d0,a0        ; and get adress
        move.l a0,addr
        move.w taille,(a0)  ; put the new size in the string header
        add.w taille,a0
        move.b #45,1(a0)    ; and make it a string
                
                            ; but in fact, it is a temp string since
                            ; the size given must be too larger
                            ; but now don't hnow the good size so...
        move.l addr,a0       
        lea 2(a0),a0         ;
        clr.b (a0)+          ; ici va commencer l'entete du string

        move.l text_addr,a1
        lea 5(a1),a1         ; ici on l'entete du texte

\copy   move.b (a1)+,(a0)+   ; on copie le contenu du texte
        tst.b (a1)           ; dans le string en respectant
        beq exit             ; la syntaxe
        cmp.b #13,(a1)
        bne.s \copy
\retour cmp.b #13,2(a1)
        beq \saute
        move.b #124,(a0)+
\saute  add.l #2,a1
\cpy    tst.b (a1)
        beq make
        cmp.b #13,(a1)
        beq \retour
        move.b (a1)+,(a0)+
        bra \cpy

make    cmp.b #124,-1(a0)  ; now must make a new string with the good size
        beq \cut
        clr.b (a0)+
\cut    clr.b -1(a0)

        move.l addr,a0
        lea.l 3(a0),a0
        move.l a0,-(a7)
        ROM_CALL romfunc::strlen ; so take the lenght of the string
        lea 4(a7),a7
        move.w d0,taille         ; add 5 to make a file
        add.w #5,d0
        and.b #$000000FF,d0
        move.l d0,-(a7)
        ROM_CALL romfunc::HeapAlloc ; and alloc a new block of memory
        lea 4(a7),a7
        tst.w d0
        beq make_error_4         ; not enough memory => quit

        move.l vat,a0
        move.w d0,12(a0)         ; remplace the new handle

        _DEREF d0,a0             ; put the size on the header
        move.w taille,d0
        add.w #3,d0
        move.w d0,(a0)
        add.l #3,a0
        move.l addr,a1
        add.l #3,a1

\transfert:                      ; copy the temp string in the new string
        move.b (a1)+,(a0)+       ;
        tst.b (a1)               ;
        bne.s \transfert         ;

        clr.b (a0)+              ; make it a string
        move.b #45,(a0)

        move.w handle,-(a7)      ; last thing: erase the old block of memory
        ROM_CALL romfunc::HeapFree
        lea 2(a7),a7
        pea.l _comment(pc)
        ROM_CALL romfunc::ST_showHelp
        lea 4(a7),a7
        bra exit                 ; ok, that's all folks...

make_error_3:
        pea.l error_3(pc)
        bra.s disp_error
make_error_4:
        pea.l error_4(pc)
disp_error
        ROM_CALL romfunc::ST_showHelp
        lea 4(a7),a7
exit    movem.l (a7)+,d0-d7/a0-a6
        rts


text_addr   dc.l 0
taille      dc.w 0
handle      dc.w 0
addr        dc.l 0
vat         dc.l 0


error_3     dc.b "Wrong text format",0
error_4     dc.b "Not enough memory",0

value       dc.b 45,0
text_value  dc.b 224,0

_comment    dc.b "Text To Str by Alban Gervaise",0

         end

; Txttostr (Text to String)
; by Alban Gervaise
; written on PlusShell v1.0a
; last release 21/04/99
